#ifndef ndestyleanimations_h
#define ndestyleanimations_h

#include "ndestylewidgetstateengine.h"

#include <QObject>
#include <QList>

namespace NdeStyle
{
class Animations: public QObject
{

    Q_OBJECT

public:
    explicit Animations( QObject* );
    virtual ~Animations( void );
    void registerWidget( QWidget* widget ) const;
    void unregisterWidget( QWidget* widget ) const;

    WidgetStateEngine& widgetStateEngine( void ) const;
    WidgetStateWidthEngine& widgetStateWidthEngine( void ) const;

protected Q_SLOTS:
    void unregisterEngine( QObject* );
private:
    void registerEngine( BaseEngine* engine );
    WidgetStateEngine* _widgetStateEngine;

    WidgetStateWidthEngine* _widgetStateWidthEngine;

    QList< BaseEngine::Pointer > _engines;

};

}

#endif
