#ifndef ndestyledatamap_h
#define ndestyledatamap_h

#include "ndestyle.h"

#include <QObject>
#include <QMap>
#include <QPoint>
#include <QWidget>


namespace NdeStyle
{
template< typename T > class DataMap: public QMap<  const QObject *, WeakPointer<T> >
{
public:
    using Key = const QObject *;
    using Value = WeakPointer<T>;

    DataMap( void ):
        QMap<Key, Value>()
    {}
    virtual ~DataMap( void )
    {}
    Value find( Key key )
    {
        if( !key ) return Value();
        Value out;
        typename QMap<Key, Value>::iterator iter( QMap<Key, Value>::find( key ) );
        if( iter != QMap<Key, Value>::end() ) out = iter.value();
        return out;
    }
    bool unregisterWidget( Key key )
    {
        if( !key ) return false;

        typename QMap<Key, Value>::iterator iter( QMap<Key, Value>::find( key ) );
        if( iter == QMap<Key, Value>::end() ) return false;

        // delete value from map if found
        if( iter.value() ) iter.value().data()->deleteLater();
        QMap<Key, Value>::erase( iter );
        return true;
    }
};



}

#endif
