#ifndef ndestylegenericdata_h
#define ndestylegenericdata_h

#include "ndestylematerialripple.h"
#include <QObject>
#include <QWidget>

namespace NdeStyle
{
class RippleData{
public:
    RippleData( void ):
        radius(0),
        width(0),
        opacity(-1)
    {}
    qreal radius;
    qreal width;
    qreal opacity;
    QPoint center;
};

class RippleWidthData{
public:
    RippleWidthData( void ):
        width(0),
        opacity(-1)
    {}
    qreal width;
    qreal opacity;
};

class GenericData: public QObject
{
    Q_OBJECT
public:
    GenericData( QObject* parent, QWidget* widget);
    virtual ~GenericData( void );

    virtual void addRipple(MaterialRipple *ripple);

    QList<RippleData> ripples( void );

    QWidget *target() const;
public Q_SLOTS:
    void removeRipple();
    void removeAllRipple();
private:
    QList<MaterialRipple *> m_animations;
    QWidget *m_target;
};


class GenericWidthData: public QObject
{
    Q_OBJECT
public:
    GenericWidthData( QObject* parent, QWidget* widget);
    virtual ~GenericWidthData( void );

    virtual void addWidthRipple(MaterialWidthRipple *ripple);
    QList<RippleWidthData> widthRipples();

    void removeAllRipple();
    QWidget *target() const;

public Q_SLOTS:
    void removeRipple();
    //void removeProgressRipple();
private:
    QList<MaterialWidthRipple *> m_widthAnimations;
    QWidget *m_widthTarget;
};

}

#endif
