#ifndef ndestylewidgetstatedata_h
#define ndestylewidgetstatedata_h
#include "ndestylegenericdata.h"

namespace NdeStyle
{





class WidgetStateData: public GenericData
{
    Q_OBJECT
public:
    WidgetStateData( QObject* parent, QWidget* target );

    virtual bool eventFilter( QObject* object, QEvent* event );

    virtual ~WidgetStateData( void );

    //设置波纹圆心
    void setRippleDataPoint(QPoint center);
    //设置波纹半径
    void setRippleDataRadios(int radius);
protected:
    void startRipple(QMouseEvent *event, QWidget * target);

    void startTabHoverRipple(QMouseEvent *event, QWidget * target);
    void startTabRipple(QMouseEvent *event, QWidget * target);

    void startHover(QMouseEvent *event, QWidget * target);
    void startPress(QMouseEvent *event, QWidget * target);
    void endHover(QMouseEvent *event, QWidget * target);

protected Q_SLOTS:
    void hoverShow();
    void tabHoverShow();
//    void endTabPressRipple();

private:
    //是否使用设置的圆心
    bool usecenter;
    //是否使用设置的半径
    bool useradius;
    //波纹动画的数据
    RippleData rippledata;

    qreal radiusMaxValue;
    int cnt;
    bool bHovering;
    bool bPressed;

    bool bTabHovering;
    bool bTabPressed;
};


class WidgetStateWidthData: public GenericWidthData
{
    Q_OBJECT
public:
    WidgetStateWidthData( QObject* parent, QWidget* target );

    virtual bool eventFilter( QObject* object, QEvent* event );

    virtual ~WidgetStateWidthData( void );

    void setRippleDataTabWidth(qreal width);
protected Q_SLOTS:
    void endProgressBusyRipple();
protected:
    void startRipple(QMouseEvent *event, QWidget * target);
    void endRipple(QMouseEvent *event, QWidget * target);
    void startCheckBoxMarkRipple(QMouseEvent *event, QWidget * target);
    void startRadioButtonRipple(QMouseEvent *event, QWidget * target);
    void startProgressBusyRipple(QMouseEvent *event, QWidget * target);

    void startTabLineRipple(QMouseEvent *event, QWidget * target);
protected Q_SLOTS:
    void test();

private:
    bool bBusy;
    bool bMoving;
    qreal tabWidth;
};


}

#endif
