#include "comboxeventfilter.h"
#include <QEvent>
#include <QDebug>
#include <QThread>
#include <QAbstractItemView>

ComboxEventFilter::ComboxEventFilter(QObject *parent) : QObject(parent)
{
    _animation = 0;
    _vScrollBarPolicy = Qt::ScrollBarAsNeeded;
    _rect = QRect();
}

bool ComboxEventFilter::eventFilter(
        QObject *watched, QEvent *event)
{
    //隐藏动画没有显示，fix me
//    if(event->type() == QEvent::Hide)
//    {
//        QAbstractItemView* itemView = qobject_cast<QAbstractItemView*>(watched);
//        if(itemView)
//        {
//            if(!_animation) initAnimation(itemView);
//            itemView->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
//            _animation->setDirection(QPropertyAnimation::Forward);
//            if(_animation->state() == QPropertyAnimation::Running)
//            {
//                _animation->pause();
//            }
//            _animation->start();
//        }
//    }
    if(event->type() == QEvent::Show)
    {
        QAbstractItemView* itemView = qobject_cast<QAbstractItemView*>(watched);
        if(itemView)
        {
            resetAnimation(itemView);
            _animation->setDirection(QPropertyAnimation::Backward);
            if(_animation->state() == QPropertyAnimation::Running)
            {
                _animation->pause();
            }
            _animation->start();
        }
    }
    return QObject::eventFilter(watched,event);
}

void ComboxEventFilter::resetAnimation(QAbstractItemView *itemView)
{
    if(!_animation)
    {
       _animation = new QPropertyAnimation(itemView, "geometry");
       _animation->setDuration(200);
       connect(_animation, SIGNAL(finished()), this, SLOT(animationFinished()));
    }
    _rect = itemView->rect();
    _vScrollBarPolicy = itemView->verticalScrollBarPolicy();
    itemView->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    _animation->setStartValue(_rect);
    _animation->setEndValue(_rect.adjusted(0,0,0,-_rect.height()));
}

void ComboxEventFilter::animationFinished()
{
    if(!_animation)  return;
    QAbstractItemView *itemView = qobject_cast<QAbstractItemView *>(_animation->targetObject());
    if(itemView)
    {
        itemView->setGeometry(_rect);
        itemView->setVerticalScrollBarPolicy(_vScrollBarPolicy);
    }
}
